/* 
 * File:   main.cpp
 * Author: Олег "АндреичЪ" Клещев
 *
 * Created on 25 Июль 2009 г., 0:13
 */

#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <string.h>
#include <sstream>
#include <vector>
using namespace std;

struct bothways    /* This is a data structure for content in matrixes.       */
{                  /*It's really needed for making pathfind in both directions*/
    vector<unsigned int> forward;
    vector<unsigned int> backward;
};
char mode;
int counter=1;

unsigned int sizeofmatrix (); //function to recognize a size of graph
void prematrix_fill (vector<unsigned int> premat[]); //function to fill prevous matrix (graph)
void mainmatrix_fill (vector<unsigned int> inarg[], bothways arg[], unsigned int size); //fills mainmatrix with data
void showmethematrix (bothways incomin[], unsigned int dims);//shows the content of matrix
bool watch_pretender (bothways pret[], unsigned int size);//returns a statement of pretender
//0 - undecided
//1 - gamilton
bool vertex_counting (bothways matrix[],unsigned int size);
//returns 1 if some shit happens;
void kill_deadlock (bothways matrix[], unsigned int size, int line, int cell, int forwarder);
//kills deadlocks
void likeahobbit (bothways matrix[], unsigned int size);
//back and forth )))
//hmm... where is the Gendalf? I need one white mage! ^_^
void clearmatrix (bothways matrix[], unsigned int size);
//clears content of the matrix
void alternative (bothways matrix[], unsigned int size);

int main(int argc, char** argv)
{

    unsigned int matsize = sizeofmatrix();

    cout << "If you want to use automated mode enter a\n"
         << "If you want a manual mode press m\n";
    cin >> mode;

    if(mode=='m')
    {
        cout << "There is "
        << matsize << " lines\n\n"; //shows content of file and how much lines
    }

    vector<unsigned int> prematrix [matsize];
    prematrix_fill(prematrix); //filling prematrix
    if (mode=='m')
    {
        cout << "Content of prematrix\n";
        for (int i=0; i<matsize; i++) //shows content of prematrix
        {
            cout << "|";
            for (int k=0; k<matsize; k++)
            {
                for (int j=0; j<prematrix[i].size(); j++)
                {
                    if (prematrix[i][j]-1==k)
                    {
                        cout << prematrix[i][j];
                    }
                }
                cout << "|";
                if (k==matsize-1)
                    cout << endl;
            }
        }
    }

    bothways mainmatrix [matsize*(matsize+1)];//this is main matrix ))
    mainmatrix_fill(prematrix, mainmatrix, matsize);
        
    bool statement=0;
    
    do
    {
        if (mode=='m')
        cout << "and again\n";
        cout << "Now counting midmatrix # " << counter << endl;
        statement=watch_pretender(mainmatrix, matsize);
        counter++;
        if (mode=='m')
        {
            cout << "If you want to continue in manual mode enter m, elswhere a\n";
            cin >> mode;
        }
    }
    while (statement==0);

    cout << "AND FINALLY!!!\n";
    cout << "Result at " << counter << " midmatrix.\n";
    showmethematrix (mainmatrix, matsize);
    alternative (mainmatrix, matsize);

    return (EXIT_SUCCESS);
}

unsigned int sizeofmatrix ()
{
    string line;
    int howmuchlines=0;

    ifstream infile;
    infile.open ("input");
    if (infile.is_open())
    {
     if (mode=='m')
     cout << "Counting lines:\n";
     while (! infile.eof())
     {
        getline (infile, line);
        if (mode=='m')
        cout << line << endl;
        //shows content of file

        if (line != "")
        //gets off empty lines
        howmuchlines++;
        //counts lines

     }
    }
    else
    {
        cout << "Unable to open file!\n";
        exit(0);
    }
    infile.close();
    return howmuchlines;
}

void prematrix_fill (vector<unsigned int> premat[])
{
    int i=0; //iteration counter
    string line="", buffer="";

    ifstream infile;
    infile.open("input");

    if (infile.is_open())
    {
        if (mode=='m')
        cout << "Filling prematrix...\n";
        while (! infile.eof())
        {
            getline (infile, line);
            if (line != "")
            //gets off empty lines
            {
                for (int j=0; j<line.length(); j++)
                {
                    if (j != line.length()-1)
                    {
                        if (line.substr(j,1) != " ")
                        {
                            buffer += line.substr(j,1);
                        }
                        else
                        {
                            if (buffer=="0")
                            {
                                cout << "Nicht gamilton ^_^\n" << "Tupikoven vershinen ))\n";
                                exit(0);
                            }
                            premat[i].push_back(atoi(buffer.c_str()));
                            buffer="";
                        }
                    }
                    else
                    {
                        if (line.substr(j,1) != " ")
                        {
                            buffer += line.substr(j,1);
                            premat[i].push_back(atoi(buffer.c_str()));
                            buffer="";
                        }
                        else
                        {
                            premat[i].push_back(atoi(buffer.c_str()));
                            buffer="";
                        }
                    }
                }
            }
            i++;
        }
        if (mode=='m')
        cout << "End of filling\n\n";
        infile.close();
    }
    else
    {
        cout << "Unable to open file\n";
        exit(0);
    }
}

void mainmatrix_fill (vector<unsigned int> inarg[], bothways arg[], unsigned int size)
//inarg - prematrix, arg - mainmatrix, size - matsize

{
    bothways argbuffer[size*(size+1)]; 
    //Stores temproary routes during backward pathfinding

    bool vertex_counter [size];//allows to know if all vertex are used

    for (int i=0; i<size; i++) //marks all vertexes as unused
    {
        vertex_counter[i]=0;
    }
    
    argbuffer[0].forward=inarg[0];
    //fills first vertex
    for (int i=0; i<argbuffer[0].forward.size(); i++)
    //fills info from the first vertex
    {
            argbuffer[size+argbuffer[0].forward[i]-1].backward.push_back(1);
            for (int j=0; j<inarg[argbuffer[0].forward[i]-1].size(); j++)
            {
                if (inarg[argbuffer[0].forward[i]-1][j] != 1)
                {
                    argbuffer[size+argbuffer[0].forward[i]-1].forward.push_back(inarg[argbuffer[0].forward[i]-1][j]);
                }
            }
    }

    bool mark=0;
    for (int i=1; i<size; i++)
    //fills other vertexes
    //i - current array's line
    {
        for (int j=1; j<size; j++)
        //j - current array's cell
        {
            for (int k=0; k<argbuffer[i*size+j].forward.size(); k++)
            //k - current vector's cell
            {
                mark=0;
                if (i<size-2)
                {
                    for (int n=0; n<argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward.size(); n++)
                    {
                        if (argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward[n] == j+1)
                        {
                            mark=1;
                        }
                    }
                    if (mark == 0)
                    {
                        argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward.push_back(j+1);
                    }
                    for (int n=0; n<inarg[argbuffer[i*size+j].forward[k]-1].size(); n++)
                    {
                        if (inarg[argbuffer[i*size+j].forward[k]-1][n] != 1)
                        {
                            mark=0;
                            for (int l=0; l<argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].forward.size(); l++)
                            {
                                if (argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].forward[l] == inarg[argbuffer[i*size+j].forward[k]-1][n])
                                {
                                    mark=1;
                                }
                            }
                            if (mark == 0)
                            {
                                argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].forward.push_back(inarg[argbuffer[i*size+j].forward[k]-1][n]);
                            }
                        }
                    }
                }
                if (i==size-2)
                {
                    for (int n=0; n<argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward.size(); n++)
                    {
                        if (argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward[n] == j+1)
                        {
                            mark=1;
                        }
                    }
                    if (mark == 0)
                    {
                        argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward.push_back(j+1);
                    }
                    for (int n=0; n<inarg[argbuffer[i*size+j].forward[k]-1].size(); n++)
                    {
                        mark=0;
                        for (int l=0; l<argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].forward.size(); l++)
                        {
                            if (argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].forward[l] == inarg[argbuffer[i*size+j].forward[k]-1][n])
                            {
                                mark=1;
                            }
                        }
                        if (mark == 0)
                        {
                            argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].forward.push_back(inarg[argbuffer[i*size+j].forward[k]-1][n]);
                        }
                    }
                }
                if (i==size-1)
                {
                    if (argbuffer[size*i+j].forward[k] == 1)
                    {
                        for (int n=0; n<argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward.size(); n++)
                        {
                            if (argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward[n] == j+1)
                            {
                                mark=1;
                            }
                        }
                        if (mark == 0)
                        {
                            argbuffer[size*(i+1)+argbuffer[i*size+j].forward[k]-1].backward.push_back(j+1);
                        }
                    }
                }
            }
        }
    }
    // huh, forward is done ^_^

    vertex_counter[0]=1;
    if (argbuffer[size*size].backward.size() == 0)
    {
        cout << "Gamilton wasn't there because there's no loop\n";
        exit(1);
    }
    else
    {
        arg[size*size].backward=argbuffer[size*size].backward;
    }

    for (int i=0; i<argbuffer[size*size].backward.size(); i++)
    {
        arg[size*(size-1)+argbuffer[size*size].backward[i]-1].forward.push_back(1);
        arg[size*(size-1)+argbuffer[size*size].backward[i]-1].backward=argbuffer[size*(size-1)+argbuffer[size*size].backward[i]-1].backward;
        for (int j=0; j<argbuffer[size*(size-1)+argbuffer[size*size].backward[i]-1].backward.size(); j++)
        {
            vertex_counter[argbuffer[size*(size-1)+argbuffer[size*size].backward[i]-1].backward[j]-1]=1;
        }
        for (int j=0; j<argbuffer[size*size].backward.size(); j++)
        {
            vertex_counter[argbuffer[size*size].backward[j]-1]=1;
        }
    }

    if (arg[size*size].backward.size()!=0)
        vertex_counter[size-1]=1;

    for (int i=size-1; i>0; i--)
    {
        for (int j=1; j<size; j++)
        {
            for (int l=0; l<arg[i*size+j].backward.size(); l++)
            {
                vertex_counter[arg[i*size+j].backward[l]-1]=1;
                arg[(i-1)*size+arg[i*size+j].backward[l]-1].backward=argbuffer[(i-1)*size+arg[i*size+j].backward[l]-1].backward;
                mark=0;
                for (int n=0; n<arg[(i-1)*size+arg[i*size+j].backward[l]-1].forward.size(); n++)
                {
                    if (arg[(i-1)*size+arg[i*size+j].backward[l]-1].forward[n] == j+1)
                    {
                        mark=1;
                    }
                }
                if (mark==0)
                {
                    arg[(i-1)*size+arg[i*size+j].backward[l]-1].forward.push_back(j+1);
                }
            }
        }
    }
    showmethematrix (arg, size);
    
    bool all=1;
    for (int i=0; i<size; i++) //marks all vertexes as unused
    {
        if (vertex_counter[i]==0)
            all=0;
    }
    if (all==0)
    {
        cout << "Not all veretexes used\n It's not gamilton\n";
        exit(1);
    }
}


void showmethematrix (bothways incomin[], unsigned int dims)
{
    cout << "Contents\n";
    for (int i=0; i<=dims; i++)
    {
        if (i!=dims)
        {
            for (int j=0; j<dims; j++)
            {
                cout << "|";
                if (!incomin[i*dims+j].forward.empty())
                {
                    cout << j+1;
                }
                if (j==dims-1)
                {
                    cout << "|" << endl;
                }
            }
        }
        if (i==dims)
        {
            for (int j=0; j<dims; j++)
            {
                cout << "|";
                if (!incomin[i*dims+j].backward.empty())
                {
                    cout << j+1;
                }
                if (j==dims-1)
                {
                    cout << "|"<< endl;
                }
            }
        }
    }
}

bool watch_pretender (bothways pret[], unsigned int size)
{
    showmethematrix(pret, size);
    int thisstep, nextstep, thisstep2, nextstep2, incount=0;
    bothways pretender[size*(size+1)];
    bool ko=1;
    
    for (int i=0; i<size; i++)
    {
        for (int j=0; j<size; j++)
        {
            thisstep = i*size+j;
            if (pret[thisstep].forward.size() != 0)
            {
                for (int k=0; k<pret[thisstep].forward.size(); k++)
                {
                    incount++;
                    nextstep = (i+1)*size+pret[thisstep].forward[k]-1;
                    cout << "Current position is " << i+2 << " line " << pret[thisstep].forward[k] << " cell\n";
                    for (int n=0; n<size*(size+1); n++)
                    {
                        pretender[n].forward.clear();
                        pretender[n].backward.clear();
                    }
                    
                    pretender[thisstep].backward=pret[thisstep].backward;
                    pretender[thisstep].forward.push_back(pret[thisstep].forward[k]);
                    pretender[nextstep].backward.push_back(j+1);
                    pretender[nextstep].forward=pret[nextstep].forward;
                    
                    if (i!=0)
                    {
                        for (int n=i; n>0; n--)
                        {
                            for (int l=0; l<size; l++)
                            {
                                thisstep2 = n*size+l;
                                if (pretender[thisstep2].backward.size()!=0)
                                {
                                    for (int f=0; f<pretender[thisstep2].backward.size(); f++)
                                    {
                                        nextstep2 = (n-1)*size+pretender[thisstep2].backward[f]-1;
                                        if ((pretender[thisstep2].backward[f]-1!=j)&&(pretender[thisstep2].backward[f]!=pretender[thisstep].forward[0]))
                                        {
                                            pretender[nextstep2].backward=pret[nextstep2].backward;
                                            pretender[nextstep2].forward.push_back(l+1);
                                        }
                                        if (i==size-1 && n==1)
                                        {
                                            pretender[nextstep2].backward=pret[nextstep2].backward;
                                            pretender[nextstep2].forward.push_back(l+1);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    for (int n=i+1; n<size; n++)
                    {
                        for (int l=0; l<size; l++)
                        {
                            thisstep2 = n*size+l;
                            if (pretender[thisstep2].forward.size()!=0)
                            {
                                for (int f=0; f<pretender[thisstep2].forward.size(); f++)
                                {
                                    nextstep2 = (n+1)*size+pretender[thisstep2].forward[f]-1;
                                    if ((pretender[thisstep2].forward[f]-1!=j)&&(pretender[thisstep2].forward[f]!=pretender[thisstep].forward[0]))
                                    {
                                        pretender[nextstep2].forward=pret[nextstep2].forward;
                                        pretender[nextstep2].backward.push_back(l+1);
                                    }
                                    if (i==0 && n==size-1)
                                    {
                                        pretender[nextstep2].forward=pret[nextstep2].forward;
                                        pretender[nextstep2].backward.push_back(l+1);
                                    }
                                }
                            }
                        }
                    }
                    if (mode=='m')
                    {
                        cout << "It was an " << incount << " inmatrix at " << counter << " midmatrix.\n";
                        showmethematrix(pretender, size);
                    }
                    if (vertex_counting(pretender, size)==1)
                    {
                        kill_deadlock (pret, size, i, j, pret[thisstep].forward[k]);
                        ko=0;
                    }
                }
            }
        }
    }
    if (ko==0)
        return (0);
    else
        return (1);
}

bool vertex_counting (bothways matrix[],unsigned int size)
{
    bool vertex_counter[size];
    int thisstep;

    for (int i=0; i<size; i++) //marks all vertexes as unused
    {
        vertex_counter[i]=0;
    }

    if (matrix[0].forward.size()==0 && matrix[size*size].backward.size()==0)
    {
        cout << "No 1st' vertex forward or backward\n";
        return (1);
    }
    vertex_counter[0]=1;
    for (int i=0; i<size; i++)
    {
        for (int j=0; j<size; j++)
        {
            thisstep=i*size+j;
            for (int f=0; f<matrix[thisstep].forward.size(); f++)
            {
                vertex_counter[matrix[thisstep].forward[f]-1]=1;
            }
        }
    }
    bool mark=0;
    for (int i=0; i<size; i++)
    {
        if (vertex_counter[i]==0)
            mark=1;
    }
    if (mark==1)
    {
        cout<< "Not all vertexes used\n";
        return (1);
    }
    else
        return(0);
}

void kill_deadlock (bothways matrix[], unsigned int size, int line, int cell, int forwarder)
{
    for (int i=0; i<matrix[line*size+cell].forward.size(); i++)
    {
        if (matrix[line*size+cell].forward[i]==forwarder)
        {
            matrix[line*size+cell].forward.erase(matrix[line*size+cell].forward.begin()+i);
        }
    }
    for (int i=0; i<matrix[(line+1)*size+forwarder-1].backward.size(); i++)
    {
        if (matrix[(line+1)*size+forwarder-1].backward[i]==cell+1)
        {
            matrix[(line+1)*size+forwarder-1].backward.erase(matrix[(line+1)*size+forwarder-1].backward.begin()+i);
        }
    }

    showmethematrix(matrix, size);

    likeahobbit (matrix, size);
}

void likeahobbit (bothways matrix[], unsigned int size)
{
    bothways buffer[size*(size+1)];
    unsigned int thisstep, nextstep;

    buffer[0].forward=matrix[0].forward;
    //making of the 1st vertex in buffer

    for (int i=0; i<size; i++)
    {
        for (int j=0; j<size; j++)
        {
            thisstep=i*size+j;
            for (int k=0; k<buffer[thisstep].forward.size(); k++)
            {
                nextstep=(i+1)*size+buffer[thisstep].forward[k]-1;
                buffer[nextstep].backward.push_back(j+1);
                if (buffer[nextstep].forward.size()!=matrix[nextstep].forward.size())
                buffer[nextstep].forward=matrix[nextstep].forward;
            }
        }
    }

    clearmatrix(matrix, size);

    matrix[size*size].backward=buffer[size*size].backward;
    
    for (int i=0; i<matrix[size*size].backward.size(); i++)
    //filling prelast row from the last vertex
    {
        matrix[size*(size-1)+matrix[size*size].backward[i]-1].forward.push_back(1);
        matrix[size*(size-1)+matrix[size*size].backward[i]-1].backward=buffer[size*(size-1)+matrix[size*size].backward[i]-1].backward;
    }

    for (int i=size-1; i>0; i--)
    {
        for (int j=0; j<size; j++)
        {
            thisstep=i*size+j;
            for (int k=0; k<matrix[thisstep].backward.size(); k++)
            {
                nextstep=(i-1)*size+matrix[thisstep].backward[k]-1;

                matrix[nextstep].forward.push_back(j+1);
                matrix[nextstep].backward=buffer[nextstep].backward;
            }
        }
    }
}

void clearmatrix (bothways matrix[], unsigned int size)
{
    for (int i=0; i<size*(size+1); i++)
    {
        matrix[i].forward.clear();
        matrix[i].backward.clear();
    }
}

void alternative (bothways matrix[], unsigned int size)
{
    vector<unsigned int> steps;
    int choice_step, choice_vertex;
    bool nochoise=0, end=0, many, mark=0;
    while (nochoise==0)
    {
        nochoise=1;
        while (!end)
        {
            for (int i=1; i<size-1; i++)
            {
                many=0;
                mark=0;
                int j=1;
                while (j<size && many==0)
                {
                    if ((matrix[i*size+j].forward.size()!=0) && mark==1)
                    {
                        many=1;
                        nochoise=0;
                        steps.push_back(i);
                    }
                    if ((matrix[i*size+j].forward.size()!=0) && mark==0)
                        mark=1;
                    j++;
                }
                if (i==size-2)
                end=1;
            }
        }

        unsigned int accum, j, i=0;
        while (i<steps.size() && !steps.empty())
        {
            accum=0;
            j=1;
            while (j<size && accum<2)
            {
                if (matrix[steps[i]*size+j].forward.size()!=0)
                {
                    accum++;
                }
                j++;
            }
            if (accum<2 && !steps.empty())
            {
                steps.erase(steps.begin()+i);
                i=0;
            }
            else
                i++;
        }

        if (!steps.empty())
            {
            for (int i=0; i<steps.size(); i++)
            {
                cout << "You have ";
                for (int j=1; j<size; j++)
                {
                    if (matrix[steps[i]*size+j].forward.size()!=0)
                        cout << j+1 << " ";
                }
                cout << "vertexes on " << steps[i]+1 << " step\n";
            }
            cout << "Choose step\n";
            cin >> choice_step;
            choice_step-=1;
            cout << "and a vertex\n";
            cin >> choice_vertex;
            choice_vertex-=1;
            for (int i=1; i<size; i++)
            {
                if ((i!=choice_vertex) && (matrix[choice_step*size+i].backward.size()!=0))
                {
                    matrix[choice_step*size+i].backward.clear();
                    matrix[choice_step*size+i].forward.clear();
                }
            }

            watch_pretender(matrix, size);
            showmethematrix (matrix, size);
        }
    }
}